=== debian/changelog ===
suitesparse-graphblas (6.0.0+dfsg-3) unstable; urgency=medium

  * Breaks/Replaces against suitesparse for -dev and -doc packages

 -- Vincent Prat <vivi@debian.org>  Fri, 26 Nov 2021 17:35:44 +0100

suitesparse-graphblas (6.0.0+dfsg-2) unstable; urgency=medium

  * Use the correct Maintainer email address

 -- Vincent Prat <vivi@debian.org>  Wed, 17 Nov 2021 23:00:07 +0100

suitesparse-graphblas (6.0.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #999561)

 -- Vincent Prat <vivi@debian.org>  Wed, 17 Nov 2021 22:23:53 +0100
