=== debian/changelog ===
suitesparse-graphblas (6.1.4+dfsg-2) unstable; urgency=medium

  * Mark arch-specific symbols

 -- Vincent Prat <vivi@debian.org>  Mon, 31 Jan 2022 08:40:46 +0100

suitesparse-graphblas (6.1.4+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update d/copyright and symbol file
  * Remove useless Breaks/Replaces statements for -doc package

 -- Vincent Prat <vivi@debian.org>  Sat, 29 Jan 2022 19:05:32 +0100
